require "import" 
local cjson=require "cjson" 
import "android.widget.*" 
import "com.androlua.*" 
import "android.content.Intent" 
import "android.content.Context" 
 
local Symbol={} 
local path=this.getLuaExtDir("Plugins").."/مفضلتي/data.json" 
 
---读取符号文件函数 
local function readSymbol(path) 
 local file,eor=io.open(path,"r") 
 local t={} 
 if eor==nil then 
  local data=file:read('*a') 
  if data~="" then 
   t=cjson.decode(data) 
   file:close() 
  end 
 end 
 return t 
end 
 
---写入符号函数 
local function writeSymbol(t,path) 
 file=io.open(path,'w') 
 if #t>0 then 
  file:write(cjson.encode(t)) 
 end 
 file:close() 
end 
 
---移动函数 
local function moveItem(t,k,itemKey) 
 local s=t[k+1] 
 if itemKey==0 and k>5 then 
  table.insert(t,k-5,s) 
  table.remove(t,k+2) 
  elseif itemKey==1 and #t-k>=7 then 
  table.insert(t,k+8,s) 
  table.remove(t,k+1) 
  elseif itemKey==2 and k>0 then 
  t[k],t[k+1]=t[k+1],t[k] 
  elseif itemKey==3 and k+1<#t then 
  t[k+1],t[k+2]=t[k+2],t[k+1] 
  elseif itemKey==4 then 
  table.remove(t,k+1) 
 end 
end 
 
---编辑框界面 
local edit=loadlayout({ 
 EditText; 
 hint="ضع رمزا أو عبارة, يقبل أكثر مِنْ سطر" 
}) 
local et=LuaDialog() 
et.setTitle("إضافة") 
et.setView(edit) 
et.setButton("حِفْظْ",function() 
if edit.text~='' then 
table.insert(Symbol,edit.text) 
edit.text='' 
writeSymbol(Symbol,path) 
end 
--重新载入符号表 
grid.adapter=SingleLineAdapter(service,String(Symbol)) 
dlg.show() 
end) 
 
---说明界面 
local readme=LuaDialog(service) 
readme.setTitle("الوصف") 
readme.setMessage("هذه مفضلة نستطيع أن نضع فيها الرموز, أو العبارات. \nالإصدار：V1.0 \nالمطور：coolsnowbye\n") 
readme.setButton("إغلاق",function() 
dlg.show() 
end) 
 
---长按菜单 
local menuItem= 
{ 
 "نَقْلُ العُنْصُرِ لِلْأعلى", 
 "نَقْلُ العُنْصُرِ لِلْأسْفَلْ", 
 "نَقْلُ العُنْصُرِ لِلْيسارْ", 
 "نَقْلُ العُنْصُرِ لِلْيَمِينْ", 
 "حَذْفْ", 
} 
local menuDlg=LuaDialog(service) 
--menuDlg.setTitle("مفضلتي") 
menuDlg.setItems(menuItem) 
 
---主界面 
layout={ 
GridView, 
id="grid", 
numColumns=6, 
background="#ff00002e",
layout_width="fill", 
layout_height="fill" 
} 
 
dlg=LuaDialog(service) 
dlg.View=loadlayout(layout) 
Symbol=readSymbol(path) 
grid.adapter=SingleLineAdapter(service,String(Symbol)) 
dlg.setButton2("إغلاق") 
dlg.setButton("إضافة",function(v) 
task(50,function() 
et.show() 
end) 
end) 
dlg.setButton3("الوصف",function(v) 
readme.show() 
end) 
 
dlg.show() 
grid.onItemClick=function(l,v,p)
dlg.dismiss()
service.pasteText(node,v.text)
service.speak(v.text)
table.insert(Symbol,1,v)
table.remove(Symbol,p+2)
writeSymbol(Symbol,path)
return true
end
 
grid.onItemLongClick=function(l,v,p,i) 
dlg.dismiss() 
vibrator = this.getSystemService(Context.VIBRATOR_SERVICE) 
vibrator.vibrate( long{50,30} ,-1) 
menuDlg.show() 
menuDlg.onItemClick=function(_,_,itemKey) 
menuDlg.dismiss() 
moveItem(Symbol,i,itemKey) 
writeSymbol(Symbol,path) 
--重新载入符号表 
grid.adapter=SingleLineAdapter(service,String(Symbol)) 
dlg.show() 
end 
 
end